String.prototype.startsWith = function(str) {
    return (this.match("^"+str)==str)
}

const TB_VERSION = 5;

//const BASE_URL = "http://bundeskampf.dev.spielwerk.eu/";
const BASE_URL = "http://www.bundeskampf.com/";
const FORUM_BASE_URL = "http://forum.bundeskampf.com/";
const REDIRECT_URL = BASE_URL + "toolbars/tbr";

// Constants
var URLs = Array();
URLs['login'] 		= BASE_URL + "signups/login";
URLs['start'] 		= BASE_URL + "characters/index";
URLs['quests'] 		= BASE_URL + "quests/start";
URLs['fights'] 		= BASE_URL + "fights/start";
URLs['jobs'] 		= BASE_URL + "arbeitsamt/index";
URLs['msg']             = BASE_URL + "pns";
URLs['updateToolbar']   = BASE_URL + "toolbars/index";
URLs['msgCentral'] 	= BASE_URL + "pns";
URLs['msgNews'] 	= BASE_URL + "pns";
URLs['msgPns'] 		= BASE_URL + "pns/index/newMsg/";
URLs['msgFights'] 	= BASE_URL + "pns/index/newFights/";
URLs['news']            = BASE_URL + "characters/index";
URLs['forum']           = FORUM_BASE_URL;
URLs['buy']             = BASE_URL + "zwerge/index";
URLs['items']           = BASE_URL + "items/index";

var actionCats = Array("quests", "fights", "jobs");
var msgCats = Array("central", "news", "pns", "fights");

var UPDATE_EVERY        = 5000; // milliseconds
var usr;    // the user object

var questCountdown = 0;

var doPnBlink = false;
var pnBlink = 0;

var isFirstRequest = true;
var strings;


var myTime = function() {
	var r = parseInt(new Date().getTime()/1000);
	bktb.debug("r: " + r + " timeCorrection: " + usr.timeCorrection);
	r = r + usr.timeCorrection;
	bktb.debug("r2: " + r);
		
    return r;
}

const DO_DEBUG = false;

var bktb = {
    debug: function(s) {
        if (DO_DEBUG) {
            dump( new Date() + ": overlay.js: " + s +"\n");
        }
    },
	
    initialPageLoad: function() {
        bktb.debug("initialPageLoad");
        if (isFirstRequest) {
            isFirstRequest = false;

            // initialization code
            strings = document.getElementById("bundeskampftoolbar-strings");

            // init toolbar
            bktb.getUpdateFromCon();
            // bktb.updateUser();

            //gBrowser.addEventListener("load", bktb.onPageLoad, true);
            window.removeEventListener("load", bktb.initialPageLoad, true);
        }
    },



    /* Component Interaction */
    getUpdateFromCon: function() {
        //bktb.debug("getUpdateFromCon");
        bktbConnect.getUpdate();        
    },

    notifyByBktbConnect: function(obj) {
        var r = false;
        if (typeof bktb == 'undefined') {
            r = false;
        } else {
            bktb.processObj(obj);
            //            bktb.updateToolbar();
            r = true;
        }

        return r;
    },

    processObj: function(obj) {
        if (obj == false) {
            bktb.setHidden(true);
        }


        if (obj.updateEvery) {
            bktb.debug('resetting interval to: ' + obj.updateEvery);
            UPDATE_EVERY= obj.updateEvery;
            window.clearInterval(updateEveryInterval);
            updateEveryInterval = window.setInterval("bktb.getUpdateFromCon()", UPDATE_EVERY);
        }

        if (obj.type == "ERR") {
            bktb.setHidden(true);
        } else if (obj.type == "USR") {
            usr = obj;

            if (usr.tbMinVersion <= TB_VERSION) {
                bktb.updateToolbar();
            } else {
                bktb.newerVersion();
            }
        }
    },



    /* Toolbar stuff */
    onOpenWindowCommand: function(e, href) {
        if (href == "msg") {
            doPnBlink = false;
        }

        if (href == "news") {
            document.getElementById("new-news-buttons").setAttribute("hidden", true);
        }

        var criteria = BASE_URL;
        if (href == "forum") {
            criteria = FORUM_BASE_URL;
        }

        bktb.openAndReuseOneTabPerURL(href, URLs[href], criteria);
    },

    openAndReuseOneTabPerURL: function(href, url, criteria) {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
        .getService(Components.interfaces.nsIWindowMediator);
        var browserEnumerator = wm.getEnumerator("navigator:browser");

        // Check each browser instance for our URL
        var found = false;
        while (!found && browserEnumerator.hasMoreElements()) {
            var browserWin = browserEnumerator.getNext();
            var tabbrowser = browserWin.gBrowser;

            // Check each tab of this browser instance
            var numTabs = tabbrowser.browsers.length;
            for (var index = 0; index < numTabs; index++) {
                var currentBrowser = tabbrowser.getBrowserAtIndex(index);
                //if (url == currentBrowser.currentURI.spec) {
                if (currentBrowser.currentURI.spec.startsWith(criteria)) {
                    //alert(url);
                    // switch URL
                    if (currentBrowser.contentDocument.location.href != url) {
                        currentBrowser.contentDocument.location.href = bktb.redirectUrl(href);
                    }

                    // The URL is already opened. Select this tab.
                    tabbrowser.selectedTab = tabbrowser.tabContainer.childNodes[index];

                    // Focus *this* browser-window
                    browserWin.focus();

                    found = true;
                    break;
                }
            }
        }

        // Our URL isn't open. Open it now.
        if (!found) {
            var recentWindow = wm.getMostRecentWindow("navigator:browser");
            if (recentWindow) {
                // Use an existing browser window
                recentWindow.delayedOpenTab(bktb.redirectUrl(href), null, null, null, null);
            }
            else {
                // No browser windows are open, so open a new one.
                window.open(bktb.redirectUrl(href));
            }
        }
    },

    redirectUrl: function(href) {
        var r = REDIRECT_URL + "/" + href + "/" + TB_VERSION;
        return r;
    },

    updateToolbar: function() {
        bktb.debug("updateToolbar");

		bktb.debug("timeCorrection: " + usr.timeCorrection);

        bktb.setHidden(false);

        // PNs
        var btn = document.getElementById("new-msg-btn");
        var label;

        if (usr.msgs.pns.hasPns || usr.msgs.fights.hasFights) {
            btn.setAttribute("image", "chrome://bundeskampftoolbar/skin/img/neue-nachricht.png");
            label = strings.getString("msg.hasNewMessages");
            doPnBlink = true;
        } else {
            btn.setAttribute("image", "chrome://bundeskampftoolbar/skin/img/nachricht.png");
            label = strings.getString("msg.noNewMessages");
            doPnBlink = false;
        }
        btn.setAttribute("label", label);

        if (usr.msgs.pns.hasPns) {
            URLs['msg'] = URLs['msgPns'];
        } else {
            if (usr.msgs.fights.hasFights) {
                URLs['msg'] = URLs['msgFights'];
            } else {
                URLs['msg'] = BASE_URL + "pns";
            }
        }


        // News
        if (usr.msgs.news.hasNews) {
            label = strings.getString("msgs.news") + " " + usr.msgs.news.title;
            btn = document.getElementById("new-news-btn");
            btn.setAttribute("label", label);

            document.getElementById("new-news-buttons").setAttribute("hidden", false);
        } else {
            document.getElementById("new-news-buttons").setAttribute("hidden", true);
        }

        if (usr.powercrystals < 5) {
            document.getElementById("powercrystals-btn").setAttribute("class", "powercrystals-btn-less");
        } else {
            document.getElementById("powercrystals-btn").setAttribute("class", "powercrystals-btn");
        }

        this.countdown();
    },

    setHidden: function(hidden) {
        if (document.getElementById("action-buttons") == null) {
            bktb.debug("document: null");
        }
        
        if (hidden) {
            document.getElementById("action-buttons").setAttribute("hidden", hidden);
            document.getElementById("new-message-buttons").setAttribute("hidden", hidden);
            document.getElementById("right-buttons").setAttribute("hidden", hidden);
            document.getElementById("login-buttons").setAttribute("hidden", !hidden);
        } else {
            document.getElementById("action-buttons").setAttribute("hidden", hidden);
            document.getElementById("new-message-buttons").setAttribute("hidden", hidden);
            document.getElementById("right-buttons").setAttribute("hidden", hidden);
            document.getElementById("login-buttons").setAttribute("hidden", !hidden); 
        }
    },

    pnBlink: function() {
        var btn = document.getElementById("new-msg-btn");
        if (!doPnBlink) {
            btn.setAttribute("class", "new-msg-btn-0");
        } else {
            if (pnBlink == 0) {
                btn.setAttribute("class", "new-msg-btn-0");
                pnBlink = 1;

            } else {
                btn.setAttribute("class", "new-msg-btn-1");
                pnBlink = 0;
            }
        }
    },

    countdown: function() {
        if (usr) {
            bktb.fightsCountdown();
            bktb.questsCountdown();
            bktb.jobsCountdown();
        }
    },

    fightsCountdown: function() {
        var btn = document.getElementById("action-fights-btn");
        var label = strings.getString("action.fights");

        if (usr.actions['fights'].active) {
            btn.setAttribute("class", "action-fights-btn-active");
        } else {
            btn.setAttribute("class", "action-fights-btn-not-active");
        }

        //bktb.debug(usr.actions['fights'].noFightUntil);
        if (usr.actions['fights'].noFightUntil > 0) {
            label += " " + strings.getString("action.fights.until");

//            var now = parseInt(new Date().getTime()/1000);
			var now = myTime();
            var timeLeft = usr.actions['fights'].noFightUntil - now;
            if (timeLeft < 0) {
                timeLeft = 0;
                btn.setAttribute("class", "action-fights-btn-active-wait");
            }

            var cdts = bktb.countDownTimeStringMinSec(timeLeft);
            label += " ( " + cdts +" )";
        }

        btn.setAttribute("label", label);
    },

    jobsCountdown: function() {
        var btn = document.getElementById("action-jobs-btn");
        var label = strings.getString("action.jobs");

        if (usr.actions['jobs'].active) {
            var now = myTime();

            if (usr.actions['jobs'].ends > now) {
                var timeLeft = usr.actions.jobs.ends - now;
                if (timeLeft < 0) {
                    timeLeft = 0;
                    btn.setAttribute("class", "action-jobs-btn-active-finished");
                } else {
                    btn.setAttribute("class", "action-jobs-btn-active-working");
                }

                var cdts = bktb.countDownTimeString(timeLeft);
                label += " ( " + cdts +" )";
            }
        } else {
            btn.setAttribute("class", "action-jobs-btn-not-active");
        }

        btn.setAttribute("label", label);
    },

    questsCountdown: function() {
        var btn = document.getElementById("action-quests-btn");
        var label = strings.getString("action.quests");
        var riskLabel = strings.getString("action.quests.risk");


        if (usr.actions['quests'].active) {
            var now = myTime();
            var timeLeft = 0;
            var timeDone = 0;
            var sub = 0;
            var risk;

            timeDone = now - usr.actions.quests.start;

            var hasActiveRisk = false;

            if (usr.actions.quests.risks) {
                var risks = usr.actions.quests.risks;
                for (var i in risks) {
                    risk = risks[i];

                    //bktb.debug(risk.start + " < " + now + " < " + risk.end);
                    if ((risk.start <= now) && (now <= risk.end)) { // stop countdown
                        hasActiveRisk = true;
                    }

                    if (risk.end <= now) {
                        sub = (risk.end - risk.start);
                        timeDone = timeDone - sub;
                    } else {
                        if (risk.start <= now) {
                            sub = (now - risk.start);
                            //bktb.debug("sub2: " + sub);
                            timeDone = timeDone - sub;
                        }
                    }
                }

                if (hasActiveRisk) { // stop countdown
                    btn.setAttribute("class", "action-quests-btn-active-risk");
                    label = riskLabel;
                } else {    // do countdown
                    btn.setAttribute("class", "action-quests-btn-active");
                }
            }

            timeLeft = usr.actions.quests.duration - timeDone;
            if (timeLeft < 0) {
                timeLeft = 0;
                btn.setAttribute("class", "action-quests-btn-active-finished");
            }

            var cdts = bktb.countDownTimeStringMinSec(timeLeft);

            label += " ( " + cdts +" )";
        } else {
            var styleClass = "action-quests-btn";
            if (usr.nb == 3) {
                styleClass = "action-quests-btn-unvisited";
            }

            btn.setAttribute("class", styleClass);
            questCountdown = 0;
        }

        btn.setAttribute("label", label);
    },

    newerVersion: function() {
        document.getElementById("action-buttons").setAttribute("hidden", true);
        document.getElementById("new-message-buttons").setAttribute("hidden", true);
        document.getElementById("login-buttons").setAttribute("hidden", true);
        document.getElementById("right-buttons").setAttribute("hidden", true);
        document.getElementById("update-buttons").setAttribute("hidden", false);
    },

    countDownTimeString: function(timeLeft) {
        var hours = 0;
        var minutes = 0;
        var seconds = 0;
        hours = Math.floor(timeLeft / 3600);
        minutes = Math.floor((timeLeft - (hours * 3600)) / 60);
        if (minutes < 10) {
            minutes = "0" + minutes;
        }
        seconds = Math.floor((timeLeft - (hours * 3600) - (minutes * 60)));
        if (seconds < 10) {
            seconds = "0" + seconds;
        }

        var s = hours + "h "+minutes+"m " + seconds +"s";
        return s;
    },

    countDownTimeStringMinSec: function(timeLeft) {
        var minutes = 0;
        var seconds = 0;
        minutes = Math.floor(timeLeft / 60);
        if (minutes < 10) {
            minutes = "0" + minutes;
        }
        seconds = Math.floor((timeLeft - (minutes * 60)));
        if (seconds < 10) {
            seconds = "0" + seconds;
        }

        var s = minutes + "m " + seconds + "s";
        return s;
    }

};

// init
window.addEventListener("load", bktb.initialPageLoad, false);


// updater
var updateEveryInterval = window.setInterval("bktb.getUpdateFromCon()", UPDATE_EVERY);
window.setInterval("bktb.pnBlink()", 1000);
window.setInterval("bktb.countdown()", 1000);


var bktbConnect;
//try {
    // this is needed to generally allow usage of components in javascript
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

    bktbConnect = Components.classes['@bundeskampf.com/bktbconnect;1']
        .getService().wrappedJSObject;

    bktbConnect.register();

    bktbConnect.addToolbar(bktb.notifyByBktbConnect);

    //bktb.debug(bktbConnect.getUsr());
//} catch (anError) {
//    dump("ERROR: " + anError);
//}